<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2013 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

function mail_utf8($addr, $subject, $message, $headers) {
  $header_ = 'MIME-Version: 1.0' . "\r\n" . 'Content-type: text/plain; charset=UTF-8' . "\r\n";
  mail($addr, '=?UTF-8?B?'. base64_encode($subject) . '?=', $message, $header_ . $headers);
}

function send_login_information($database, $email, $password, $username, $auth_handle) {
  global $strings;
  global $site_url;
  global $site_title;

  $failures = 0;
  $new_passwords = FALSE;

  if (($password === FALSE) &&
      ($username === FALSE)) {
    $new_passwords = TRUE;
  }

  $email = pg_escape_string($database, $email);
  $password = pg_escape_string($database, $password);
  $username = pg_escape_string($database, $username);

  if ($username != '') 
    $extra = "and (username = '$username' or email = '$username')";
  else
    $extra = "";

  $valid_emails = pg_query($database, "
     select first_name, last_name, email, username, '$password' as password
       from users
      where email = '$email' $extra");

  $num_of_valid_emails = pg_num_rows($valid_emails);
  if ($num_of_valid_emails == 0)
    return FALSE;

  $admin_data = pg_fetch_row(pg_query($database, "
     select users.first_name, users.last_name, email
       from users
      where users.type = ".PO_USER_TYPE_ADMIN));

  for ($i = 0; $i < $num_of_valid_emails; $i++) {
    $user_data = pg_fetch_assoc($valid_emails, $i);

    if ($new_passwords) {
      if ($auth_handle->local_register === TRUE) {
	$user_data['password'] = generate_password();
	$auth_handle->force_change_pass($user_data['username'], $user_data['password']);
      } else {
	$user_data['password'] = '??unknown??';
      }
    }

    eval('$subject = "'. $strings['mail_login_info_subject']. '";');

    $message = $strings['mail_login_info'];
    $message .= $strings['mail_mail_bottom'];

    eval('$message = "'. $message. '";') ;

    $headers = "From: $admin_data[0] $admin_data[1] <$admin_data[2]>\r\n";

    if (!mail_utf8($user_data['email'], $subject, $message, $headers))
      $failures++;
  }
  if ($failures == 0)
    return TRUE;

  return FALSE;
}

function send_new_client_notification($database, $user_id, $client_id) 
{
  global $site_url;
  global $site_title;
  global $strings;

  $user_data = pg_query($database, "
     select users.first_name, users.last_name, email
       from users
      where users.identifier = '$user_id'");

  $num_of_to_users = pg_num_rows($user_data);
  if ($num_of_to_users != 1)
    return FALSE;

  $client_data = pg_query($database, "
     select users.first_name, users.last_name, email,
            client_status.value as status, client_status.identifier as statusid, client.date_of_creation as date_of_subscirption
       from users, client, client_status
      where client.status = client_status.identifier
        and client.client = '$client_id'
        and client.users = '$user_id'
        and users.identifier = client.client");

  $num_of_from_users = pg_num_rows($client_data);
  if ($num_of_from_users != 1)
    return FALSE;

  $client_data = pg_fetch_row($client_data);
  $user_data   = pg_fetch_row($user_data);

  $admin_data = pg_fetch_row(pg_query($database, "
     select users.first_name, users.last_name, email
       from users
      where users.type = ".PO_USER_TYPE_ADMIN));

  /* SEND MAIL TO THE USER */

  $client_data[3] = $strings['generic_'.$client_status[$client_data[3]]];
  $client_data[5] = substr($client_data[5], 0, 10);
  eval('$subject = "'. $strings['mail_new_client_subject']. '";');

  $message = $strings['mail_new_sub_top'];

  if ($client_data[4] == PO_CLIENT_PENDING)
    $message .= $strings['mail_new_sub_pending'];
  else if ($client_data[4] == PO_CLIENT_ACCEPTED)
    $message .= $strings['mail_new_sub_accepted'];

  $message .=  $strings['mail_mail_bottom'];

  eval('$message = "'.$message . '";');

  $headers = "From: $admin_data[0] $admin_data[1] <$admin_data[2]>\r\n";

  if (!mail_utf8($user_data[2], $subject, $message, $headers))
    return FALSE;

  /* SEND MAIL TO THE CLIENT */

  eval('$subject = "'. $strings['mail_new_client_subject']. '";');
  $message = $strings['mail_new_client_top'];

  if ($client_data[4] == PO_CLIENT_PENDING)
    $message .= $strings['mail_new_client_pending'];
  else if ($client_data[4] == PO_CLIENT_ACCEPTED)
    $message .= $strings['mail_new_client_accepted'];

  $message .= $strings['mail_client_footer'];
  $message .=  $strings['mail_mail_bottom'];

  eval('$message = "'.$message . '";');

  $headers = "From: $admin_data[0] $admin_data[1] <$admin_data[2]>\r\n";

  if (!mail_utf8($client_data[2], $subject, $message, $headers))
    return FALSE;

  return TRUE;
}

function send_client_account_change_notification($database, $user_id, $client_id) {
  global $site_title;
  global $site_url;
  global $strings;

  $user_data = pg_query($database, "
     select users.first_name, users.last_name, email
       from users
      where users.identifier = '$user_id'");

  $num_of_to_users = pg_num_rows($user_data);
  if ($num_of_to_users != 1)
    return FALSE;

  $client_data = pg_query($database, "
     select users.first_name, users.last_name, email,
            client_status.value as status, client_status.identifier as statusid, client.date_of_creation as date_of_subscirption
       from users, client, client_status
      where client.status = client_status.identifier
        and client.client = '$client_id'
        and client.users = '$user_id'
        and users.identifier = client.client");

  $num_of_from_users = pg_num_rows($client_data);
  if ($num_of_from_users != 1)
    return FALSE;

  $client_data = pg_fetch_row($client_data);
  $user_data   = pg_fetch_row($user_data);

  $admin_data = pg_fetch_row(pg_query($database, "
     select users.first_name, users.last_name, email
       from users
      where users.type = ".PO_USER_TYPE_ADMIN));

  /* SEND MAIL TO THE CLIENT */
  eval('$subject = "'. $strings['mail_client_status_subject']. '";');

  $message = $strings['mail_client_status_top'];

  if ($client_data[4] == PO_CLIENT_PENDING)
    $message .= $strings['mail_client_status_pending'];
  if ($client_data[4] == PO_CLIENT_REJECTED)
    $message .= $strings['mail_client_status_rejected'];
  if ($client_data[4] == PO_CLIENT_ACCEPTED)
    $message .= $strings['mail_client_status_accepted'];

  $message .= $strings['mail_client_footer'];
  $message .=  $strings['mail_mail_bottom'];
  eval('$message = "'.$message . '";');

  $headers = "From: $admin_data[0] $admin_data[1] <$admin_data[2]>\r\n";

  if (!mail_utf8($client_data[2], $subject, $message, $headers))
    return FALSE;

  return TRUE;
}

function send_po_account_change_notification($database, $user_id) {
  global $site_title;
  global $site_url;
  global $strings;
  global $po_options_default;

  $user_data = pg_query($database, "
     select users.first_name, users.last_name, email, user_type.identifier, value, 
          get_user_pref(users.identifier, 'bulk_upload_enable'),     
	  'f' as shop_enable,
          get_user_pref(users.identifier, 'quota_size'),
          get_user_pref(users.identifier, 'quota_count')
       from users, user_type
      where users.type = user_type.identifier
        and users.identifier = '$user_id'");

  $num_of_to_users = pg_num_rows($user_data);
  if ($num_of_to_users != 1)
    return FALSE;

  $user_data   = pg_fetch_row($user_data);
  $admin_data = pg_fetch_row(pg_query($database, "
     select users.first_name, users.last_name, email
       from users
      where users.type = ".PO_USER_TYPE_ADMIN));

  if (!$user_data[5])
    $user_data[5] = $po_options_default['bulk_upload_enable'];

  if ($user_data[5]=='t')
    $user_data[5] = "Enabled";
  else
    $user_data[5] = "Disabled";

  /* SEND MAIL TO THE USER */
  eval('$subject = "'. $strings['mail_account_status_subject']. '";');

  if ($user_data[7])
    $user_data[7] = round($user_data[7]/1048576, 2);
  else
    $user_data[7] = $po_options_default['quota_size'];

  if (!$user_data[8])
    $user_data[8] = $po_options_default['quota_count'];

  $message = $strings['mail_account_status'];
  $message .=  $strings['mail_mail_bottom'];

  eval('$message = "'.$message . '";');

  $headers = "From: $admin_data[0] $admin_data[1] <$admin_data[2]>\r\n";

  if (!mail_utf8($user_data[2], $subject, $message, $headers))
    return FALSE;

  return TRUE;
}

?>
